#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <cmath>
#include <stdio.h>  
#include <stdlib.h>   

using namespace std;

// globale Variablen
const int N = 3;
const int M = 5; 


//=========================================================
// I/O
//=========================================================

// write 2D data
void write2D( const double x[M], const double y[M], const char* filename ) {
  ofstream out ( filename );
  for( int i = 0; i < M; i++ )
    out << x[i] << " " << y[i] << endl;
}

// read 2D data
void read2D( double x[M], double y[M], const char* filename ) {
    
  std::ifstream readfile ( filename );
  std::string line;
  
  int i = 0;
  while( (!readfile.eof()) && (i < M) ){
   
   std::getline( readfile, line );
   std::stringstream ss( line );
   ss >> x[i] >> y[i];
   i++;
  }

}

//=========================================================
// CONSOLE OUTPUT
//=========================================================

//
void printMatrix ( double A[M][N] ) {
  for( int i = 0; i < M; i++ ){
    for( int j = 0; j < N; j++ )
      cerr << A[i][j] << " ";
    cerr << endl;
  }
  cerr << endl;
}

//
void printVector ( double x[N] ) {
  for( int j = 0; j < N; j++ )
    cerr << x[j] << " ";
  cerr << endl;
  cerr << endl;
}

//=========================================================
// SYSTEM SETUP
//=========================================================


// Matrix aus Aufgabe 15 
void buildMatrix( double A[M][N] ) {
  
  if( M != 5 )
    throw "ERROR in buildMatrix()! Wrong number of rows!";
   
  if( N != 3 )
    throw "ERROR in buildMatrix()! Wrong number of columns!";
   
  for( int i = 0; i < M; i++ )
    for( int j = 0; j < N; j++ )
      A[i][j] = 0;
    
  A[0][0] = 2.; A[0][2] = 1.;
  A[1][1] = 2.; A[1][2] = 7.;
  A[2][1] = 6.; 
  A[3][1] = 3;
  A[4][0] = std::sqrt( 12 ); A[4][2] = std::sqrt( 3 );
}


//TODO
void buildFourierSystem( double t[M], double A[M][N] ) {
  // fill t and A
  //TODO
}

//=========================================================
// QR - ALGORITHM
//=========================================================

// QR - Zerlegung mit Householder
// TODO
void computeQR( double A[M][N], double b[M] ) {
     
  if( M < N )
   throw "ERROR in computeQR()! Number of rows should no be smaller than number of columns!";
  
  // N = min( M, N )
  for( int i = 0; i < N; i++ ){
    
    // z ist i-te Spalte (unterhalb des Diagonalelements)
    //TODO
    
    // v ist Normale der Ebene, an der gespiegelt wird
    //TODO

    // H = \id - 2 v v^T
    //TODO

  }

}

//TODO
void solveSystemWithQR( double A[M][N], double rhs[M], double sol[N] ){  
  
  computeQR( A, rhs );   
    
  // backward
  // TODO
  
}

// z_k = \sum_i x_i sin(i t_k) for k = 1, ..., M and x being the coefficients
void evaluateFourierSeries( double t[M], double z[M], double coeff[N] ) { 
  // TODO
}


//=========================================================
//=========================================================

// Hauptprogramm
int main () {
    
  try{      
    
  static double A[M][N];
  static double b[M];
  static double sol[N];  
  
  // ---------------------------------  
  // AUFGABE 3
  // ---------------------------------
  
  buildMatrix( A );
  printMatrix( A );
     
  clock_t begin, end;
  
  begin = clock();   
  solveSystemWithQR( A, b, sol );
  end = clock();
  
  cerr << "Time = " << double(end - begin) / CLOCKS_PER_SEC << endl;
  
  printMatrix( A );  
  printVector( sol );
  
  }
  catch ( const char* exc ){
    cerr << "Exception caught: " << exc << endl;
  }

  return 0;
}